using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Text;
using SuperMap.Data;
using SuperMap.Mapping;
using SuperMap.Desktop;
using SuperMap.Desktop.UI;

namespace SuperMap.Desktop.DeleteRepeatedAttribute
{
    class ExcuteCtrlAction : CtrlAction
    {
        public ExcuteCtrlAction(IBaseItem caller)
            : base(caller)
        {
 
        }

        public override void Run()
        {
            try
            {
                IFormTabular mainForm = SuperMap.Desktop.Application.ActiveForm as IFormTabular;     
                
                IRibbonManager ribbonManager = SuperMap.Desktop.Application.ActiveApplication.MainForm.RibbonManager;
                ITextBox txtField = ribbonManager[typeof(_CtrlActionTxtField)] as ITextBox;
                String strField = txtField.Text;
                
                if (strField == null || strField.Length == 0)
                {
                    SuperMap.Desktop.Application.ActiveApplication.Output.Output("Please input a right field name!");
                }

                
                DatasetVector datasetVector = mainForm.TabularControl.Recordset.Dataset;

                QueryParameter queryParameter = new QueryParameter();
                queryParameter.CursorType = CursorType.Static;
                queryParameter.HasGeometry = false;
                String[] arrGroupBy = new String[1];
                String[] arrResultFields = new String[1];
                arrGroupBy[0] = strField;
                arrResultFields[0] = strField;
                queryParameter.GroupBy = arrGroupBy;
                queryParameter.ResultFields = arrResultFields;

                //Get unique values
                Recordset groupRs = datasetVector.Query(queryParameter);

                //Get the number of groups
                int groupCount = groupRs.RecordCount;  
  
                int m = 0;
                //GroupValue is used to store the value for each group
                String[] groupValue = new String[groupCount];

                groupRs.MoveFirst();
                for (m = 0; m < groupCount; m++)
                {
                    //Place the repeated values in the GroupValue array
                    groupValue[m] = groupRs.GetFieldValue(strField).ToString();
                    groupRs.MoveNext();
                }
                groupRs.Close();
                groupRs.Dispose();

                (mainForm as Form).Close();

                //Delete the records with repeated values
                for (m = 0; m < groupCount; m++)    
                {
                    Recordset recordSet = datasetVector.Query(strField + "='" + groupValue[m] + "'", CursorType.Dynamic);
                    int recCount = recordSet.RecordCount - 1;
                    if (recCount == 0)
                    {
                        recordSet.Close();
                        recordSet.Dispose();
                        continue;
                    }
                    recordSet.MoveFirst();
                    recordSet.MoveNext();
                    for (int n = 0; n < recCount; n++)
                    {
                        recordSet.Delete();
                        recordSet.Update();
                        recordSet.MoveFirst();
                        recordSet.MoveNext();
                    }
                    recordSet.Close();
                    recordSet.Dispose();
                }

            }
            catch (Exception ex)
            {
                SuperMap.Desktop.Application.ActiveApplication.Output.Output(ex.Message);
            }
        }
        
    }
}
